diff --git a/src/widgets/articles/list.rs b/src/widgets/articles/list.rs
index 9fae278..9b7851f 100644
--- a/src/widgets/articles/list.rs
+++ b/src/widgets/articles/list.rs
@@ -7,7 +7,7 @@ use super::row::ArticleRow;
 use crate::models::{Article, ArticleAction, ObjectWrapper};
 
 pub struct ArticlesListWidget {
-    pub widget: libhandy::Column,
+    pub widget: libhandy::Clamp,
     builder: gtk::Builder,
     sender: Sender<ArticleAction>,
     client: Rc<isahc::HttpClient>,
@@ -15,8 +15,8 @@ pub struct ArticlesListWidget {
 
 impl ArticlesListWidget {
     pub fn new(sender: Sender<ArticleAction>, client: Rc<isahc::HttpClient>) -> Self {
-        let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/articles_list.ui");
-        get_widget!(builder, libhandy::Column, articles_list);
+        let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/articles_list.ui");
+        get_widget!(builder, libhandy::Clamp, articles_list);
 
         Self {
             builder,
@@ -34,13 +34,13 @@ impl ArticlesListWidget {
         empty_image.set_from_icon_name(Some(icon), gtk::IconSize::Dialog);
 
         get_widget!(self.builder, gtk::Stack, stack);
-        if model.get_n_items() == 0 {
+        if model.n_items() == 0 {
             stack.set_visible_child_name("empty");
         } else {
             stack.set_visible_child_name("articles");
         }
         model.connect_items_changed(move |model, _, _, _| {
-            if model.get_n_items() == 0 {
+            if model.n_items() == 0 {
                 stack.set_visible_child_name("empty");
             } else {
                 stack.set_visible_child_name("articles");
diff --git a/src/widgets/articles/preview.rs b/src/widgets/articles/preview.rs
index ff85a08..d35f9de 100644
--- a/src/widgets/articles/preview.rs
+++ b/src/widgets/articles/preview.rs
@@ -13,7 +13,7 @@ pub struct ArticlePreviewImage {
 
 impl ArticlePreviewImage {
     pub fn new() -> Rc<Self> {
-        let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/article_preview.ui");
+        let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/article_preview.ui");
         get_widget!(builder, gtk::Stack, article_preview);
         get_widget!(builder, gtk::DrawingArea, image);
         let pixbuf = Rc::new(RefCell::new(None));
@@ -37,28 +37,28 @@ impl ArticlePreviewImage {
         self.widget.set_visible_child_name("loading");
 
         self.image.connect_draw(move |dr, ctx| {
-            let width = dr.get_allocated_width();
-            let height = dr.get_allocated_height();
+            let width = dr.allocated_width();
+            let height = dr.allocated_height();
 
-            let style = dr.get_style_context();
+            let style = dr.style_context();
             gtk::render_background(&style, ctx, 0.0, 0.0, width.into(), height.into());
             gtk::render_frame(&style, ctx, 0.0, 0.0, width.into(), height.into());
 
             match &*d.pixbuf.borrow() {
                 Some(pixbuf) => {
-                    match pixbuf.get_width().cmp(&width) {
+                    match pixbuf.width().cmp(&width) {
                         std::cmp::Ordering::Greater => {
                             let pixbuf = pixbuf.scale_simple(width, height, gdk_pixbuf::InterpType::Bilinear).unwrap();
                             ctx.set_source_pixbuf(&pixbuf, 0.0, 0.0);
                         }
                         std::cmp::Ordering::Less => {
-                            ctx.set_source_pixbuf(&pixbuf, (width - pixbuf.get_width()) as f64, 0.0);
+                            ctx.set_source_pixbuf(&pixbuf, (width - pixbuf.width()) as f64, 0.0);
                         }
                         std::cmp::Ordering::Equal => {
                             ctx.set_source_pixbuf(&pixbuf, 0.0, 0.0);
                         }
                     };
-                    ctx.paint();
+                    ctx.paint().unwrap();
 
                     gtk::Inhibit(false)
                 }
diff --git a/src/widgets/articles/row.rs b/src/widgets/articles/row.rs
index c5f9dd2..977a0df 100644
--- a/src/widgets/articles/row.rs
+++ b/src/widgets/articles/row.rs
@@ -17,7 +17,7 @@ pub struct ArticleRow {
 
 impl ArticleRow {
     pub fn new(article: Article, client: Rc<isahc::HttpClient>, sender: Sender<ArticleAction>) -> Self {
-        let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/article_row.ui");
+        let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/article_row.ui");
         get_widget!(builder, gtk::ListBoxRow, article_row);
         let preview_image = ArticlePreviewImage::new();
 
diff --git a/src/widgets/login.rs b/src/widgets/login.rs
index 2c234be..999631b 100644
--- a/src/widgets/login.rs
+++ b/src/widgets/login.rs
@@ -3,14 +3,14 @@ use std::rc::Rc;
 use wallabag_api::types::Config;
 
 pub struct LoginWidget {
-    pub widget: libhandy::Column,
+    pub widget: libhandy::Clamp,
     pub builder: gtk::Builder,
 }
 
 impl LoginWidget {
     pub fn new() -> Rc<Self> {
-        let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/login.ui");
-        get_widget!(builder, libhandy::Column, login);
+        let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/login.ui");
+        get_widget!(builder, libhandy::Clamp, login);
 
         let login_widget = Rc::new(Self { widget: login, builder });
 
@@ -25,20 +25,20 @@ impl LoginWidget {
         get_widget!(self.builder, gtk::Entry, username_entry);
         get_widget!(self.builder, gtk::Entry, password_entry);
 
-        let instance = instance_entry.get_text()?;
+        let instance = instance_entry.text();
         let instance = instance.trim_end_matches('/').to_string();
         if let Err(err) = url::Url::parse(&instance) {
             error!("The instance url is invalid {}", err);
-            instance_entry.get_style_context().add_class("error");
+            instance_entry.style_context().add_class("error");
             return None;
         }
-        instance_entry.get_style_context().remove_class("error");
+        instance_entry.style_context().remove_class("error");
 
         Some(Config {
-            client_id: client_id_entry.get_text()?.to_string(),
-            client_secret: client_secret_entry.get_text()?.to_string(),
-            username: username_entry.get_text()?.to_string(),
-            password: password_entry.get_text()?.to_string(),
+            client_id: client_id_entry.text().to_string(),
+            client_secret: client_secret_entry.text().to_string(),
+            username: username_entry.text().to_string(),
+            password: password_entry.text().to_string(),
             base_url: instance,
         })
     }
@@ -54,8 +54,8 @@ impl LoginWidget {
 
     fn init(&self) {
         get_widget!(self.builder, gtk::TreeStore, instances_store);
-        instances_store.insert_with_values(None, None, &[0], &[&"https://app.wallabag.it/"]);
-        instances_store.insert_with_values(None, None, &[0], &[&"https://framabag.org"]);
+        instances_store.insert_with_values(None, None, &[(0, &"https://app.wallabag.it/")]);
+        instances_store.insert_with_values(None, None, &[(0, &"https://framabag.org")]);
 
         get_widget!(self.builder, gtk::ListBox, entries_listbox);
         entries_listbox.set_header_func(Some(Box::new(move |row: &gtk::ListBoxRow, row1: Option<&gtk::ListBoxRow>| {
diff --git a/src/widgets/settings.rs b/src/widgets/settings.rs
index ae2ab76..2bde0d9 100644
--- a/src/widgets/settings.rs
+++ b/src/widgets/settings.rs
@@ -22,7 +22,7 @@ pub struct SettingsWidget {
 
 impl SettingsWidget {
     pub fn new(client: Arc<Mutex<ClientManager>>) -> Rc<Self> {
-        let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/settings.ui");
+        let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/settings.ui");
         get_widget!(builder, libhandy::PreferencesWindow, settings_window);
 
         let window = Rc::new(Self {
@@ -36,12 +36,7 @@ impl SettingsWidget {
     }
 
     fn init(&self, settings: Rc<Self>, client: Arc<Mutex<ClientManager>>) {
-        self.widget.connect_key_press_event(|w, k| {
-            if k.get_keyval() == gdk::enums::key::Escape {
-                w.destroy();
-            }
-            gtk::Inhibit(false)
-        });
+        self.widget.connect_key_press_event(|_w, _k| gtk::Inhibit(false));
 
         let (sender, receiver) = glib::MainContext::channel(glib::PRIORITY_DEFAULT);
         receiver.attach(None, move |action| settings.do_action(action));
diff --git a/src/widgets/window.rs b/src/widgets/window.rs
index d540433..0adc1f7 100644
--- a/src/widgets/window.rs
+++ b/src/widgets/window.rs
@@ -1,14 +1,12 @@
 use gio::prelude::*;
 use glib::Sender;
 use gtk::prelude::*;
-use libhandy::prelude::*;
 use url::Url;
 
 use crate::application::Action;
 use crate::config::PROFILE;
 use crate::models::{Article, ArticlesManager};
 use crate::views::{ArticleView, ArticlesView, LoginView};
-use crate::window_state;
 
 #[derive(Copy, Clone, Debug, PartialEq)]
 pub enum View {
@@ -31,11 +29,11 @@ pub struct Window {
 
 impl Window {
     pub fn new(sender: Sender<Action>) -> Self {
-        let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/window.ui");
+        let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/window.ui");
         get_widget!(builder, gtk::ApplicationWindow, window);
 
         if PROFILE == "Devel" {
-            window.get_style_context().add_class("devel");
+            window.style_context().add_class("devel");
         }
         let actions = gio::SimpleActionGroup::new();
 
@@ -73,10 +71,11 @@ impl Window {
         notification_label.set_text(&message);
         notification.set_reveal_child(true);
 
-        gtk::timeout_add_seconds(5, move || {
-            notification.set_reveal_child(false);
-            glib::Continue(false)
-        });
+        // let time = std::time::Duration::new(5, 0);
+        // glib::timeout_add(time, move || {
+        //     notification.set_reveal_child(false);
+        //     glib::Continue(false)
+        // });
     }
 
     pub fn previous_view(&self) {
@@ -109,10 +108,11 @@ impl Window {
                     loading_progress.set_fraction(0.0); // Reset the fraction
                 } else {
                     loading_progress.pulse();
-                    gtk::timeout_add(200, move || {
-                        loading_progress.pulse();
-                        glib::Continue(loading_progress.get_visible())
-                    });
+                    // let time = std::time::Duration::new(0, 200);
+                    // glib::timeout_add(time, || {
+                    //     loading_progress.pulse();
+                    //     glib::Continue(loading_progress.get_visible())
+                    // });
                 }
             }
             View::NewArticle => {
@@ -127,43 +127,35 @@ impl Window {
 
     fn init(&self) {
         // setup app menu
-        let menu_builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/menu.ui");
+        let menu_builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/menu.ui");
         get_widget!(menu_builder, gtk::PopoverMenu, popover_menu);
         get_widget!(self.builder, gtk::MenuButton, appmenu_button);
         appmenu_button.set_popover(Some(&popover_menu));
-        // load latest window state
-        window_state::load(&self.widget);
-
-        // save window state on delete event
-        self.widget.connect_delete_event(move |window, _| {
-            window_state::save(&window);
-            Inhibit(false)
-        });
 
         get_widget!(self.builder, libhandy::Squeezer, squeezer);
         get_widget!(self.builder, gtk::Stack, headerbar_stack);
         get_widget!(self.builder, libhandy::ViewSwitcherBar, switcher_bar);
         get_widget!(self.builder, gtk::Label, title_label);
 
-        squeezer.connect_property_visible_child_notify(move |squeezer| {
-            let visible_headerbar_stack = headerbar_stack.get_visible_child_name();
-            if let Some(visible_child) = squeezer.get_visible_child() {
+        squeezer.connect_visible_child_notify(move |squeezer| {
+            let visible_headerbar_stack = headerbar_stack.visible_child_name();
+            if let Some(visible_child) = squeezer.visible_child() {
                 switcher_bar.set_reveal(visible_child == title_label && visible_headerbar_stack == Some("articles".into()));
             }
         });
         self.widget.connect_size_allocate(move |widget, allocation| {
             if allocation.width <= 450 {
-                widget.get_style_context().add_class("sm");
-                widget.get_style_context().remove_class("md");
-                widget.get_style_context().remove_class("lg");
+                widget.style_context().add_class("sm");
+                widget.style_context().remove_class("md");
+                widget.style_context().remove_class("lg");
             } else if allocation.width <= 600 {
-                widget.get_style_context().add_class("md");
-                widget.get_style_context().remove_class("sm");
-                widget.get_style_context().remove_class("lg");
+                widget.style_context().add_class("md");
+                widget.style_context().remove_class("sm");
+                widget.style_context().remove_class("lg");
             } else {
-                widget.get_style_context().add_class("lg");
-                widget.get_style_context().remove_class("sm");
-                widget.get_style_context().remove_class("md");
+                widget.style_context().add_class("lg");
+                widget.style_context().remove_class("sm");
+                widget.style_context().remove_class("md");
             }
         });
     }
@@ -185,8 +177,8 @@ impl Window {
         main_stack.add_named(&self.article_view.get_widget(), &self.article_view.name);
         self.widget.insert_action_group("article", self.article_view.get_actions());
 
-        main_stack.connect_property_visible_child_name_notify(clone!(@strong self.article_view as article_view => move |stack| {
-            if let Some(view_name) = stack.get_visible_child_name() {
+        main_stack.connect_visible_child_name_notify(clone!(@strong self.article_view as article_view => move |stack| {
+            if let Some(view_name) = stack.visible_child_name() {
                 article_view.set_enable_actions(view_name == "article");
             }
         }));
@@ -194,7 +186,7 @@ impl Window {
         get_widget!(self.builder, gtk::Button, save_article_btn);
         get_widget!(self.builder, gtk::Entry, article_url_entry);
         save_article_btn.connect_clicked(clone!(@strong self.sender as sender => move |_| {
-            if let Ok(url) = Url::parse(&article_url_entry.get_text().unwrap()) {
+            if let Ok(url) = Url::parse(&article_url_entry.text()) {
                 send!(sender, Action::SaveArticle(url));
                 article_url_entry.set_text("");
             }
@@ -210,7 +202,7 @@ impl Window {
             notification.set_reveal_child(false);
         });
 
-        let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/shortcuts.ui");
+        let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/shortcuts.ui");
         get_widget!(builder, gtk::ShortcutsWindow, shortcuts);
         self.widget.set_help_overlay(Some(&shortcuts));
 
